diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/channel-access-manager.cc ns-3.34/src/wifi/model/channel-access-manager.cc
--- ns-3.33/src/wifi/model/channel-access-manager.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/channel-access-manager.cc	2021-07-14 10:31:07.000000000 -0700
@@ -24,7 +24,7 @@
 #include "txop.h"
 #include "wifi-phy-listener.h"
 #include "wifi-phy.h"
-#include "mac-low.h"
+#include "frame-exchange-manager.h"
 
 namespace ns3 {
 
@@ -136,6 +136,7 @@
       i = 0;
     }
   m_phy = 0;
+  m_feManager = 0;
 }
 
 void
@@ -162,10 +163,11 @@
 }
 
 void
-ChannelAccessManager::SetupLow (Ptr<MacLow> low)
+ChannelAccessManager::SetupFrameExchangeManager (Ptr<FrameExchangeManager> feManager)
 {
-  NS_LOG_FUNCTION (this << low);
-  low->RegisterChannelAccessManager (this);
+  NS_LOG_FUNCTION (this << feManager);
+  m_feManager = feManager;
+  m_feManager->SetChannelAccessManager (this);
 }
 
 Time
@@ -264,7 +266,8 @@
    *    with that AC has now become non-empty and any other transmit queues
    *    associated with that AC are empty; the medium is busy on the primary channel
    */
-  if (!txop->HasFramesToTransmit () && !txop->GetLow ()->IsCfPeriod () && txop->GetBackoffSlots () == 0)
+  if (!txop->HasFramesToTransmit () && txop->GetAccessStatus () != Txop::GRANTED
+      && txop->GetBackoffSlots () == 0)
     {
       if (!IsBusy ())
         {
@@ -287,7 +290,7 @@
 }
 
 void
-ChannelAccessManager::RequestAccess (Ptr<Txop> txop, bool isCfPeriod)
+ChannelAccessManager::RequestAccess (Ptr<Txop> txop)
 {
   NS_LOG_FUNCTION (this << txop);
   if (m_phy)
@@ -299,13 +302,6 @@
     {
       return;
     }
-  if (isCfPeriod)
-    {
-      txop->NotifyAccessRequested ();
-      Time delay = (MostRecent ({GetAccessGrantStart (true), Simulator::Now ()}) - Simulator::Now ());
-      m_accessTimeout = Simulator::Schedule (delay, &ChannelAccessManager::DoGrantPcfAccess, this, txop);
-      return;
-    }
   /*
    * EDCAF operations shall be performed at slot boundaries (Sec. 10.22.2.4 of 802.11-2016)
    */
@@ -322,19 +318,13 @@
     }
 
   UpdateBackoff ();
-  NS_ASSERT (!txop->IsAccessRequested ());
+  NS_ASSERT (txop->GetAccessStatus () != Txop::REQUESTED);
   txop->NotifyAccessRequested ();
   DoGrantDcfAccess ();
   DoRestartAccessTimeoutIfNeeded ();
 }
 
 void
-ChannelAccessManager::DoGrantPcfAccess (Ptr<Txop> txop)
-{
-  txop->NotifyAccessGranted ();
-}
-
-void
 ChannelAccessManager::DoGrantDcfAccess (void)
 {
   NS_LOG_FUNCTION (this);
@@ -342,7 +332,7 @@
   for (Txops::iterator i = m_txops.begin (); i != m_txops.end (); k++)
     {
       Ptr<Txop> txop = *i;
-      if (txop->IsAccessRequested ()
+      if (txop->GetAccessStatus () == Txop::REQUESTED
           && GetBackoffEndFor (txop) <= Simulator::Now () )
         {
           /**
@@ -356,7 +346,7 @@
           for (Txops::iterator j = i; j != m_txops.end (); j++, k++)
             {
               Ptr<Txop> otherTxop = *j;
-              if (otherTxop->IsAccessRequested ()
+              if (otherTxop->GetAccessStatus () == Txop::REQUESTED
                   && GetBackoffEndFor (otherTxop) <= Simulator::Now ())
                 {
                   NS_LOG_DEBUG ("dcf " << k << " needs access. backoff expired. internal collision. slots=" <<
@@ -371,18 +361,30 @@
             }
 
           /**
-           * Now, we notify all of these changes in one go. It is necessary to
+           * Now, we notify all of these changes in one go if the EDCAF winning
+           * the contention actually transmitted a frame. It is necessary to
            * perform first the calculations of which Txops are colliding and then
            * only apply the changes because applying the changes through notification
            * could change the global state of the manager, and, thus, could change
            * the result of the calculations.
            */
-          txop->NotifyAccessGranted ();
-          for (auto collidingTxop : internalCollisionTxops)
+          NS_ASSERT (m_feManager != 0);
+
+          if (m_feManager->StartTransmission (txop))
+            {
+              for (auto& collidingTxop : internalCollisionTxops)
+                {
+                  collidingTxop->NotifyInternalCollision ();
+                }
+              break;
+            }
+          else
             {
-              collidingTxop->NotifyInternalCollision ();
+              // reset the current state to the EDCAF that won the contention
+              // but did not transmit anything
+              i--;
+              k = std::distance (m_txops.begin (), i);
             }
-          break;
         }
       i++;
     }
@@ -511,7 +513,7 @@
   Time expectedBackoffEnd = Simulator::GetMaximumSimulationTime ();
   for (auto txop : m_txops)
     {
-      if (txop->IsAccessRequested ())
+      if (txop->GetAccessStatus () == Txop::REQUESTED)
         {
           Time tmp = GetBackoffEndFor (txop);
           if (tmp > Simulator::Now ())
@@ -653,7 +655,7 @@
           NS_ASSERT (txop->GetBackoffSlots () == 0);
         }
       txop->ResetCw ();
-      txop->m_accessRequested = false;
+      txop->m_access = Txop::NOT_REQUESTED;
       txop->NotifyChannelSwitching ();
     }
 
@@ -712,7 +714,7 @@
           NS_ASSERT (txop->GetBackoffSlots () == 0);
         }
       txop->ResetCw ();
-      txop->m_accessRequested = false;
+      txop->m_access = Txop::NOT_REQUESTED;
       txop->NotifyWakeUp ();
     }
 }
@@ -731,7 +733,7 @@
           NS_ASSERT (txop->GetBackoffSlots () == 0);
         }
       txop->ResetCw ();
-      txop->m_accessRequested = false;
+      txop->m_access = Txop::NOT_REQUESTED;
       txop->NotifyOn ();
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/channel-access-manager.h ns-3.34/src/wifi/model/channel-access-manager.h
--- ns-3.33/src/wifi/model/channel-access-manager.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/channel-access-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -31,7 +31,7 @@
 class WifiPhy;
 class PhyListener;
 class Txop;
-class MacLow;
+class FrameExchangeManager;
 
 /**
  * \brief Manage a set of ns3::Txop
@@ -67,11 +67,11 @@
    */
   void RemovePhyListener (Ptr<WifiPhy> phy);
   /**
-   * Set up listener for MacLow events.
+   * Set up the Frame Exchange Manager.
    *
-   * \param low the MacLow to listen to
+   * \param feManager the Frame Exchange Manager
    */
-  void SetupLow (Ptr<MacLow> low);
+  void SetupFrameExchangeManager (Ptr<FrameExchangeManager> feManager);
 
   /**
    * \param txop a new Txop.
@@ -96,14 +96,23 @@
 
   /**
    * \param txop a Txop
-   * \param isCfPeriod flag whether it is called during the CF period
    *
    * Notify the ChannelAccessManager that a specific Txop needs access to the
    * medium. The ChannelAccessManager is then responsible for starting an access
-   * timer and, invoking Txop::DoNotifyAccessGranted when the access
+   * timer and, invoking FrameExchangeManager::StartTransmission when the access
    * is granted if it ever gets granted.
    */
-  void RequestAccess (Ptr<Txop> txop, bool isCfPeriod = false);
+  void RequestAccess (Ptr<Txop> txop);
+
+  /**
+   * Access will never be granted to the medium _before_
+   * the time returned by this method.
+   *
+   * \param ignoreNav flag whether NAV should be ignored
+   *
+   * \returns the absolute time at which access could start to be granted
+   */
+  Time GetAccessGrantStart (bool ignoreNav = false) const;
 
   /**
    * \param duration expected duration of reception
@@ -204,8 +213,7 @@
 
 
 protected:
-  // Inherited from ns3::Object
-  void DoDispose (void);
+  void DoDispose (void) override;
 
 
 private:
@@ -222,15 +230,6 @@
    */
   Time MostRecent (std::initializer_list<Time> list) const;
   /**
-   * Access will never be granted to the medium _before_
-   * the time returned by this method.
-   *
-   * \param ignoreNav flag whether NAV should be ignored
-   *
-   * \returns the absolute time at which access could start to be granted
-   */
-  Time GetAccessGrantStart (bool ignoreNav = false) const;
-  /**
    * Return the time when the backoff procedure
    * started for the given Txop.
    *
@@ -260,12 +259,6 @@
    * Grant access to Txop using DCF/EDCF contention rules
    */
   void DoGrantDcfAccess (void);
-  /**
-   * Grant access to Txop using PCF preemption
-   *
-   * \param txop the Txop
-   */
-  void DoGrantPcfAccess (Ptr<Txop> txop);
 
   /**
    * Return the Short Interframe Space (SIFS) for this PHY.
@@ -291,28 +284,29 @@
    */
   typedef std::vector<Ptr<Txop>> Txops;
 
-  Txops m_txops;                //!< the vector of managed Txops
-  Time m_lastAckTimeoutEnd;     //!< the last Ack timeout end time
-  Time m_lastCtsTimeoutEnd;     //!< the last CTS timeout end time
-  Time m_lastNavStart;          //!< the last NAV start time
-  Time m_lastNavDuration;       //!< the last NAV duration time
-  Time m_lastRxStart;           //!< the last receive start time
-  Time m_lastRxDuration;        //!< the last receive duration time
-  bool m_lastRxReceivedOk;      //!< the last receive OK
-  Time m_lastTxStart;           //!< the last transmit start time
-  Time m_lastTxDuration;        //!< the last transmit duration time
-  Time m_lastBusyStart;         //!< the last busy start time
-  Time m_lastBusyDuration;      //!< the last busy duration time
-  Time m_lastSwitchingStart;    //!< the last switching start time
-  Time m_lastSwitchingDuration; //!< the last switching duration time
-  bool m_sleeping;              //!< flag whether it is in sleeping state
-  bool m_off;                   //!< flag whether it is in off state
-  Time m_eifsNoDifs;            //!< EIFS no DIFS time
-  EventId m_accessTimeout;      //!< the access timeout ID
-  Time m_slot;                  //!< the slot time
-  Time m_sifs;                  //!< the SIFS time
-  PhyListener* m_phyListener;   //!< the PHY listener
-  Ptr<WifiPhy> m_phy;           //!< pointer to the PHY
+  Txops m_txops;                         //!< the vector of managed Txops
+  Time m_lastAckTimeoutEnd;              //!< the last Ack timeout end time
+  Time m_lastCtsTimeoutEnd;              //!< the last CTS timeout end time
+  Time m_lastNavStart;                   //!< the last NAV start time
+  Time m_lastNavDuration;                //!< the last NAV duration time
+  Time m_lastRxStart;                    //!< the last receive start time
+  Time m_lastRxDuration;                 //!< the last receive duration time
+  bool m_lastRxReceivedOk;               //!< the last receive OK
+  Time m_lastTxStart;                    //!< the last transmit start time
+  Time m_lastTxDuration;                 //!< the last transmit duration time
+  Time m_lastBusyStart;                  //!< the last busy start time
+  Time m_lastBusyDuration;               //!< the last busy duration time
+  Time m_lastSwitchingStart;             //!< the last switching start time
+  Time m_lastSwitchingDuration;          //!< the last switching duration time
+  bool m_sleeping;                       //!< flag whether it is in sleeping state
+  bool m_off;                            //!< flag whether it is in off state
+  Time m_eifsNoDifs;                     //!< EIFS no DIFS time
+  EventId m_accessTimeout;               //!< the access timeout ID
+  Time m_slot;                           //!< the slot time
+  Time m_sifs;                           //!< the SIFS time
+  PhyListener* m_phyListener;            //!< the PHY listener
+  Ptr<WifiPhy> m_phy;                    //!< pointer to the PHY
+  Ptr<FrameExchangeManager> m_feManager; //!< pointer to the Frame Exchange Manager
 };
 
 } //namespace ns3
